/*
 * CSkyV2.h
 *
 *  Created on: Feb 25, 2009
 *      Author: qwan
 */

#ifndef CSKYV2_H_
#define CSKYV2_H_

#include "common.h"
#include "space.h"
#include "CSet.h"

class csky {
public:
	//
	int tableNum;

	vector<PtsSpace*> tables;
	vector<PtsSpace*> package;
	vector<int*> result;

	CSet* cs;
	Pt_Collection* wregion;
	int lower;
	int upper;
	int type;
	double avg;

	PtsSpace** pack;

	csky() {
		lower = 0;
		upper = 100;
		avg = 100.0;
		pack = new PtsSpace*[100];
	}

	~csky() {
		delete cs;
	}

	void run();
	void transform();
	void freemem();
	void printStruc();
	void addto_vector(int* v, int tabNo, int ptNo);
	void calDR();
	void recurInsert(Pt_Collection*** parray, int** pbuf, int depth);
	void preprocessing();

	void setAlgo(vector<PtsSpace*> table, vector<PtsSpace*> cache, int tn);
	void clear();
	Pt_Collection* getWorstRegion();

	//	static unsigned long cmp_countH;
	//	static unsigned long cmp_countL;
	//	static unsigned long rectquery_count;
	static unsigned long skyline_count;
	static unsigned long pruned;
	//	static unsigned long memcost;
	//	static unsigned long memmax;
	//	static unsigned long pruning1;
	//	static unsigned long pruning2;
	//	static unsigned long pruning3;
	//	static int threhold;
};

#endif /* CSKYV2_H_ */
